
#ifndef _CLIP_H_
  #define _CLIP_H_

  #ifdef __cplusplus
  extern "C" {
  #endif

  typedef struct {
      int Top;
      int Left;
      int Bottom;
      int Right;
  } TCLIP;


  typedef struct TCLIP_listNode_ {
      struct TCLIP_listNode_ *Next;
      struct TCLIP_listNode_ *Prev;
      char                * Name;
      TCLIP                Rect;
      int count;
      int                 Flag;
  } TCLIP_listNode ;


  TCLIP_listNode *CLIP_findSprite(void *Source, int Border, int sizeX, int sizeY);
  TCLIP_listNode *CLIP_findAllSprites(void *Source, int Border, int sizeX, int sizeY,
                                             void (*waitFunc)(long,long)); // = NULL
  int CLIP_getRectsCount (TCLIP_listNode * Rects);
  void  *CLIP_extractSprite (void *Source, int sizeX,
                        int Left, int Top, int Right, int Bottom);
  TCLIP_listNode *CLIP_findSpriteAt (TCLIP_listNode *Rects, int x, int y);

  #ifdef __cplusplus
  }
  #endif

#endif
