
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <ctype.h>
#include <string.h>
#include <dos.h>
#include <time.h>

#include "ipxnet.h"
#include "keyb.h"
#include "win.h"
#include "tm.h"
#include "mouse.h"
#include "ipxnets.h"
#include "file.h"

#include "svga.h"
#include "car.h"
#include "csf.h"
#include "spr.h"

#ifdef __TURBOC__
  #define MESSAGES_MAX 100
#else
  #define MESSAGES_MAX 1000
#endif

//#define VIDEO_MODE XVGA_320x240x256
//#define VIDEO_MODE0

//#define DEBUG_NONET

typedef struct
{
  char Mes [256];
  int type;
} SData;

char IChatNote [] = "This message was generated by ICHAT.\n"
                   "Press ~Del~ to remove it now. Press ~Enter~ to save these messages to a file";


static int netslog;
static char Name [50];
static char Group [50];
static char Password [50];

//"~Arrows keys~=select item  ~Enter~=confirm select  ~Tab~=select Win       ~F1~=more",
//"~Del~=Logout  ~Esc~=Logout and exit  ~F10~=Startup network session           ~F1~=more", NULL};

static char *MyDefaultMiniHelp [] = {
" ~Arrows~ select  ~Enter~ confirm                                           ~F1~ more",
" ~Del~ logout  ~Esc or F10~ logout & exit                                   ~F1~ more",
" ~Tab~ next window ~Shift+Tab~ previous window                              ~F1~ more", NULL};


#define NETS_LOG_MASTER 10
#define NETS_LOG_SLAVE 20
#define NETS_LOG_NONE 0
#define NETS_LOG_CREATE 1
#define NETS_LOG_JOIN 2


static TWIN *MyWinMiniHelp;
static TWIN *MyWinMiniStatus;

static TWIN *WinWorkGroups;
static TWIN *WinUsers;
static TWIN *WinStatus;
static TWIN *WinMessages;

static TWIN *WinYesNo;
static TWIN *WinAbout;
static TWIN *WinMain;
static TWIN *WinError;
static TWIN *WinConfirm;
static TWIN *WinWait;
static TWIN *WinCommand;
static TWIN *WinCreate;
static TWIN *WinJoin;
static TWIN *WinJoinWithPassword;
static TWIN *WinPersonal;
static TWIN *WinSave;

static TCSF *spr;
static int pakHandle;
static TRGBColor pal [256];
char FileName [200];

#define M_PUBLIC 0
#define M_PERSONAL 1
#define M_NOTE 2


static SData SD;
static int CreatePassword, CreateUser, CreateGroup, JoinUser, JoinPassword, SaveName;


static int CmpItem (TWINItem *Item1, TWINItem *Item2)
{
  return memcmp ((void *) Item1, (void *) Item2, sizeof (TWINItem));
}

static void DisplayWorkGroups ()
{
  int i, j,k, GroupsCount;
  char group [256];
  TWINItem Item;

  GroupsCount = NET_GetWorkGroupsCount ();

  j = WinWorkGroups->contentCur;
  Item = WinWorkGroups->content [j];
  j = -1;

  WIN_deleteContent (WinWorkGroups);

  if (NetLocalWorkGroup.Status == NET_STATUS_NOTHING)
  {
//    WinMessages->selectable = 0;
    WinUsers->selectable = 0;
    WinCommand->selectable = 0;
//    WinMain->subWinActive = 0;

    k = WIN_appendMenu (WinWorkGroups, "", "< Create a new workgroup >\n", 0,
"To start chatting you must create a new workgroup (to do so press ~Enter~) or\n"
"join an existing workgroup (if any) using ~Arrows keys~ and ~Enter~", -1//NET_MAXLEN_DESC+1,
                        );
//    if (Item.type == WIN_ITEMT_INPUT2)
//      j = k;
  }
  else
  {
    WinMessages->selectable = 1;
//    WinUsers->selectable = 1;
    WinCommand->selectable = 1;

    strcpy (group,NetLocalWorkGroup.Desc);
    if (NetLocalWorkGroup.Password)
    {
      strcat (group, " (*)");
    }
    strcat (group,"\n");
    k = WIN_appendMenu (WinWorkGroups, "", group, 0,
                        "You have selected your workgroup. You may wish to press the ~Del~ key to logout.\n"
                        "To send messages, press ~Shift+Tab~. Press ~Enter~ to enable or disable login.\n", -1//NET_MAXLEN_DESC+1,
                        );
  }

  if (!CmpItem (&Item, &WinWorkGroups->content [k]))
    j = k;


  if (GroupsCount)
  {
    for (i = 0; i < NET_MAX_WORKGROUPS; i++)
    {
      if (NetWorkGroup [i].Status != NET_STATUS_NOTHING)
      {
        if ((NetWorkGroup [i].UsersCount < NET_MAX_USERS) && (NetWorkGroup [i].Login == NET_LOGIN_ENABLE))
        {
          strcpy (group,NetWorkGroup [i].Desc);
          if (NetWorkGroup [i].Password)
          {
            strcat (group, " (*)");
          }
          strcat (group,"\n");
          k = WIN_appendMenu (WinWorkGroups, "", group, i,
                              "You have selected a workgroup. To start chatting with them, press ~Enter~\n"
                              "If you are already connected to a different workgroup you must disconnect first.", -1 //NET_MAXLEN_DESC+1,
                               );
          if (!CmpItem (&Item,&WinWorkGroups->content [k]))
            j = k;
        }
      }
    }
  }

  if (j != -1)
  {
    if (Item.type != 0)
    {
      WinWorkGroups->contentCur = j;
      WinWorkGroups->content [j] = Item;
    }
  }
}


static void _DisplayUsers (TNetWorkGroup *Group)
{
  int i;
  char *UserType;
  char user [256];

  WIN_deleteContent (WinUsers);
  for (i = 0; i < NET_MAX_USERS; i++)
  {
    if (Group->Users [i].Status != NET_USER_STATUS_FREE)
    {
      strcat (strcpy (user,Group->Users [i].Name),"\n");
      if (i == 0)
      {
        UserType = "This user created the workgroup\n";
      }
      else
      {
        UserType = "This user has joined the workgroup\n";
      }
      WIN_appendMenu (WinUsers, "", user, i, UserType, -1);
    }
  }
}

static void _DisplayLocalUsers (TNetWorkGroup *Group)
{
  int i;
  char *UserType;
  char user [256];

  WIN_deleteContent (WinUsers);
  for (i = 0; i < NET_MAX_USERS; i++)
  {
    if (Group->Users [i].Status != NET_USER_STATUS_FREE)
    {
      strcat (strcpy (user,Group->Users [i].Name),"\n");
      if (Group->User == i)
      {
        UserType = "This is you. Press ~Del~ key to logout now.";
      }
      else
      {
        if (Group->User == 0)
        {
          if (i == 0)
          {

          }
          else
          {
            UserType = "This user has joined the workgroup.\n"
                       "Press ~Enter~ to send a personal message now. Press ~Del~ to remove.";
          }
        }
        else
        {
          if (i == 0)
          {
            UserType = "This user created the workgroup.\n"
                       "Press ~Enter~ to send a personal message now.";
          }
          else
          {
            UserType = "This user has joined the workgroup.\n"
                       "Press ~Enter~ to send a personal message now.";
          }
        }
      }
      WIN_appendMenu (WinUsers, "", user, i, UserType, -1);
    }
  }
}

static void DisplayUsers ()
{
  int i;

  i = WinWorkGroups->contentCur;
  if (i == 0)
  {
    if (netslog == NETS_LOG_NONE)
      WIN_deleteContent (WinUsers);
    if ((netslog == NETS_LOG_MASTER) || (netslog == NETS_LOG_SLAVE))//WinWorkGroups->content [i].type != WIN_ITEMT_INPUT2)
    {
      WinUsers->selectable = 1;
      _DisplayLocalUsers (&NetLocalWorkGroup);
    }
    else
    {
      if (WinMain->subWin [WinMain->subWinActive] == WinUsers)
      {
        WIN_previousSubWin (WinMain);
        WIN_show (WinMain);
//        WIN_redrawScreen ();
      }
      WinUsers->selectable = 0;
    }
  }
  else
  {
//    if ((netslog !=NETS_LOG_CREATE) && (netslog != NETS_LOG_JOIN))
    {
      WinUsers->selectable = 1;
      _DisplayUsers (&NetWorkGroup [i-1]);
    }

  }
}



#define MESSAGE_LOCAL 0
#define MESSAGE_EXTERN 1


static void InsertMessage (char *User, char *Message, char *Status, int type)
{
  char _User [WIN_ITEMLEN];
//  int itemlen;
  int itempos;
  char *s;
  char mes [256];
  int len;
  char c;

  strcpy (mes, Message);
  strcat (mes, "\n");

  itempos = WinMessages->contentCount;

  if (User == NULL)
  {
    User = "~Chat note";
  }

  strcpy (_User, User);
  s = strchr (_User, '\n');
  if (s != NULL)
    s = 0;
  if (*_User != '~')
    strcat (_User, ": ");
  else
    strcat (_User, ":");
//  itemlen = WinMessages->Size_X - strlen (_User) - strlen (Message) - 2;
  len = 76 - strlen (_User);
  if (strlen (mes)  <  len)
  {
    WIN_insertItem (WinMessages, itempos, WIN_ITEMT_MENU, _User, mes, type, Status, -1);
  }
  else
  {
    s = mes + len;
    c = *s;
    *s = 0;
    WIN_insertItem (WinMessages, itempos, WIN_ITEMT_MENU, _User, mes, type, Status, -1);
    *s = c;
    itempos = WinMessages->contentCount;
    WIN_insertItem (WinMessages, itempos, WIN_ITEMT_MENU, _User, s, type, Status, -1);
  }

  if (WinMessages->contentCur == WinMessages->contentCount-2)
  {
    WIN_scrollEnd (WinMessages);
  }

  WIN_printContent (WinMessages, 0);
}





static void DisplayMessages ()
{
  int i, j = 0, k;
  SData SD;
  char m [256];

  if (NetLocalWorkGroup.Status != NET_STATUS_NOTHING)
  {
    if (WinMessages->contentCount+5 > WinMessages->contentMax)
    {
      WIN_deleteItem (WinMessages, 0);
      WinMessages->contentCur--;
      WinMessages->contentStart--;
    }
    while (((i = NET_ReceiveEveryone ( (void *) &SD, sizeof SD)) != -1))
    {
      k = 0;

      switch (SD.type)
      {
        case M_PUBLIC:
        {
          strcpy (m, NetLocalWorkGroup.Users [i].Name);
          InsertMessage (m, SD.Mes, "This message was send to you by remote user.\n"
          "Press ~Del~ to remove it now. Press ~Enter~ to save these messages to a file", SD.type);
          break;
        }
        case M_PERSONAL:
        {
          strcpy (m, "~");
          strcat (m, NetLocalWorkGroup.Users [i].Name);
          InsertMessage (m, SD.Mes, "This ~personal~ message was send to you by remote user."
          "Press ~Del~ to remove it now. Press ~Enter~ to save these messages to a file", SD.type);
          break;
        }
      }

      if (k)
      {
        WinMessages->contentCur++;
        WIN_scrollEnd (WinMessages);
      }
      j++;
    }
    if (j)
    {
      WIN_printContent (WinMessages, WinMessages->contentStart);
//      WIN_redrawScreen ();
    }
  }
}


static void WaitBegin ()
{
  WIN_open/*Passive*/ (WinWait);
  WIN_redrawScreen ();
}

static void WaitEnd ()
{
  WIN_close (WinWait);
  WIN_redrawScreen ();
}



static void Error (int errnum, char *errstr)
{
  #define ERRORSPACE "   "
  char estr [WIN_ITEMLEN];
  strcpy (estr, ERRORSPACE);
  strcat (estr, errstr);
  abs (errnum);

  WIN_deleteContent (WinError);
  WIN_appendComment (WinError, "");
  WIN_appendComment (WinError, ERRORSPACE"~An error has occured.~");
  WIN_appendComment(WinError, "");
  WIN_appendComment(WinError, estr);
  WIN_appendComment(WinError, "");
  WIN_appendComment(WinError, "");
  WIN_appendMenu (WinError, ERRORSPACE, "< Press Escape to continue >", 0,
"Press ~Escape~ now to confirm this error messages\n", -1);

  WIN_appendComment(WinError, "");
  WIN_scrollHome (WinError);
  WIN_exec (WinError);
}

static void Confirm (/*char *errtitle,*/ char *errdesc)
{
  WIN_deleteContent (WinConfirm);
  WIN_appendComment (WinConfirm, errdesc);
  WinConfirm->contentCur = WIN_appendMenu (WinConfirm, "Press Enter to continue\n","", 0, NULL, -1);
  WIN_exec (WinConfirm);
}


static void NetInfo (void)
{
  int i;

  DisplayWorkGroups ();
  DisplayUsers ();
  WIN_printContent (WinWorkGroups, 0);
  WIN_printContent (WinUsers, 0);
}

char *GetTime (void)
{
  time_t t;

  time(&t);
  return ctime(&t);
}


static void DisplayTime (void)
{
  GetTime ();
  WIN_deleteContent (WinAbout);
  WIN_appendMenu (WinAbout, " IPX Chat 1.0~                                         ", GetTime (), -1, "", -1);
  WIN_printContent (WinAbout, 0);
}


static int NetHandler (void)
{
  int exitcode = 0;
  int i = NET_Update ();
  int user;
  char s [256];
  char name [250];

  if (i >= NET_UPDATE_LOGIN && i < (NET_UPDATE_LOGIN + NET_MAX_USERS))
  {
    user = (i - NET_UPDATE_LOGIN);
    sprintf (s, "User %s joined your workgroup.\n", NetLocalWorkGroup.Users [user].Name);
    InsertMessage (NULL, s, IChatNote, M_NOTE);
  }

  if (i >= NET_UPDATE_LOGOUT && i < (NET_UPDATE_LOGOUT + NET_MAX_USERS))
  {
    user = (i - NET_UPDATE_LOGOUT);
    strcpy (name, WinUsers->content [user].item);
    name [WIN_strlen (name)] = 0;
    sprintf (s, "User %s leaved your workgroup.", name);
    InsertMessage (NULL, s, IChatNote, M_NOTE);
  }

  if (i >= NET_UPDATE_CLEARED+1 && i < (NET_UPDATE_CLEARED + NET_MAX_USERS))
  {
    user = (i - NET_UPDATE_CLEARED);
    strcpy (name, WinUsers->content [user].item);
    name [WIN_strlen (name)] = 0;
    sprintf (s, "%s removed %s from your workgroup.", NetLocalWorkGroup.Users [0].Name, name);
    InsertMessage (NULL, s, IChatNote, M_NOTE);
  }

  switch (i)
  {
    case 0:
    {
      break;
    }

    case NET_UPDATE_LOGOUT_MASTER:
    {
      netslog = NETS_LOG_NONE;
      Error (1, "Your workgroup has been terminated.");
//      Confirm ("The workgroup was terminated by the master.");
      exitcode = -1;
      break;
    }
    case NET_UPDATE_CLEARED_U:
    {
      netslog = NETS_LOG_NONE;
      Error (1, "Your were removed from the workgroup.");
//      Confirm ("Your connection has been cleared by the master.");
      exitcode = -1;
      break;
    }

    case NET_UPDATE_MISCINFO:
    {
      break;
    }
  }

  if (i!=0)
  {
    NetInfo ();
  }

//  if ((NetLocalWorkGroup.Status == NET_STATUS_NOTHING) && (WinWorkGroups->contentCur == 0))
//  {
//    WinUsers->selectable = 0;
//  }

  DisplayTime ();

  DisplayMessages ();

  WIN_redrawScreen ();

  return exitcode;
}



int YesNo (char *Title, int X = -1, int Y = -1)
{
  int com;

  WIN_setTitle (WinYesNo, Title);
  WIN_setBounds (WinYesNo, X, Y, strlen (Title)+4, 4);
  WinYesNo->contentCur = 0;
  com = WIN_exec (WinYesNo);
  return (com == WIN_COM_ENTER);
}

void LogErr (char *mes)
{
  netslog = NETS_LOG_NONE;
  NetInfo ();
  Error (-1, mes);
}

void Login (void)
{
  int grp;
  char *s;
  int result;

  if (netslog == NETS_LOG_NONE)
  {
    if (WinWorkGroups->contentCur == 0)
    {
      netslog=NETS_LOG_CREATE;
      WIN_scrollHome (WinCreate);
      if (WIN_exec (WinCreate) == WIN_COM_ENTER)
      {
        strcpy (Name, WinCreate->content [CreateUser].item);
        Name [WIN_strlen (Name)] = 0;
        strcpy (Group, WinCreate->content [CreateGroup].item);
        Group [WIN_strlen (Group)] = 0;
        strcpy (Password, WinCreate->content [CreatePassword].item);

        switch (result = NET_Create (Group, Name, Password), result)
        {
          case NET_LOGINRESULT_SUCCESS:
          {
            WIN_deleteContent (WinMessages);
            WIN_printContent (WinMessages, 0);

            netslog = NETS_LOG_MASTER;
            NetInfo ();
            InsertMessage (NULL, "Your workgroup has been created succesfully.", IChatNote, M_NOTE);
            InsertMessage (NULL, "Please wait for other users to connect to your workgroup ...", IChatNote, M_NOTE);
            break;
          }
          case NET_LOGINRESULT_TOOMANYWORKGROUPS:
          case NET_LOGINRESULT_ALREADYLOGGED:
          default:
          {
	    LogErr ("Unable to create a new workgroup.\n"
                    "There are too many workgroups already created. Join an existing one.");
            break;
          }
        }
      }
      else
      {
        netslog = NETS_LOG_NONE;
        NetInfo ();
      }
    }
    else
    {
      netslog=NETS_LOG_JOIN;

      strcpy (Group, WinWorkGroups->content [WinWorkGroups->contentCur].item);
      Group [WIN_strlen (Group)] = 0;

      if (grp = NET_findWorkgroup (Group), grp == -1)
      {
        if (s = strstr (Group, " (*)"), s != NULL)
        {
          *s = 0;
          grp = NET_findWorkgroup (Group);
        }
      }

      if ((grp != -1) && (NetWorkGroup [grp].Password))
      {
        WIN_scrollHome (WinJoinWithPassword);
        result = WIN_exec (WinJoinWithPassword);
        {
          strcpy (Name, WinJoinWithPassword->content [JoinUser].item);
          strcpy (Password, WinJoinWithPassword->content [JoinPassword].item);
        }
      }
      else
      {
        WIN_scrollHome (WinJoin);
        result = WIN_exec (WinJoin);
        {
          strcpy (Name, WinJoin->content [JoinUser].item);
          strcpy (Password, "");
        }
      }

      if (result == WIN_COM_ENTER)
      {
        Name [WIN_strlen (Name)] = 0;

        WaitBegin ();

        result = NET_Join (Group, Name, Password);

        WaitEnd ();

        switch (result)
        {
          case NET_LOGINRESULT_SUCCESS:
          {
            WIN_deleteContent (WinMessages);
            WIN_printContent (WinMessages, 0);

            netslog = NETS_LOG_SLAVE;
            WinWorkGroups->contentCur = 0;
            NetInfo ();
            InsertMessage (NULL, "You have been logged succesfully.", IChatNote, M_NOTE);
            break;
          }
          case NET_LOGINRESULT_INVALIDGROUP:
          {
	    LogErr ("The requested workgroup does not exist.\n");
	    break;
          }
          case NET_LOGINRESULT_ACCESSDENIED:
          {
	    LogErr ("Invalid password. Access has been denied.\n");
            break;
          }
          case NET_LOGINRESULT_LOGINDISABLED:
          {
	    LogErr ("Unable to join this group. Login was disabled.\n");
            break;
          }
          case NET_LOGINRESULT_TOOMANYUSERS:
          {
	    LogErr ("There are too many users already logged in this workgroup.\n");
            break;
          }
          case NET_LOGINRESULT_ALREADYLOGGED:
          {
	    LogErr ("You are already logged in this workgroup.\n");
            break;
          }
          case NET_LOGINRESULT_TIMEOUT:
          {
	    LogErr ("Connection timed out. Try to connect later.\n");
	    break;
	  }
	  case NET_LOGINRESULT_BADNAME:
	  {
	    LogErr ("The user with your name is alredy connected.\n"
		    "Try to join again with a different name.\n");
	    break;
	  }
	  default:
	  {
	    LogErr ("An unknown error has been returned while trying to join.\n");
	  }
	}
      }
      else
      {
	netslog = NETS_LOG_NONE;
        NetInfo ();
      }
    }
  }
  else
  {
    if (WinWorkGroups->contentCur == 0)
    {
      if (YesNo ("Enable login ?"))
      {
        if (WinYesNo->contentCur == 0)
        {
          NET_EnableLogin ();
          InsertMessage (NULL, "Login is enabled.", IChatNote, M_NOTE);
        }
        else
        {
          NET_DisableLogin ();
          InsertMessage (NULL, "Login is disabled.", IChatNote, M_NOTE);
        }
      }
    }
  }
}


static void Logout ()
{
  WaitBegin ();
  NET_Logout ();
  netslog = NETS_LOG_NONE;
  WaitEnd ();
  NetInfo ();
//  WIN_deleteContent (WinMessages);
  WIN_printContent (WinMessages, 0);
}

static void Logout_ ()
{
  switch (netslog)
  {
    case NETS_LOG_SLAVE:
    {
      if (YesNo (" Logout ? "))
      {
        if (WinYesNo->contentCur == 0)
          Logout ();
      }
      break;
    }
    case NETS_LOG_MASTER:
    {
      if (YesNo (" Terminate work group ? "))
      {
        if (WinYesNo->contentCur == 0)
          Logout ();
      }
      break;
    }
  }
}


static void DeleteUser (void)
{
  char name [250];

  if (netslog != NETS_LOG_NONE)
  {
    if (WinWorkGroups->contentCur == 0)
    {
      switch (NetLocalWorkGroup.User)
      {
        case NET_USER_MASTER:
        {
          if (WinUsers->contentCur != 0)
          {
	    if (YesNo (" Remove this user ? "))
	    {
	      if (WinYesNo->contentCur == 0)
	      {
		NET_ClearSlave (WinUsers->contentCur);
		NetInfo ();
	      }
	    }
	  }
	  else
	  {
	    Logout_ ();
	  }
	  break;
	}
	default:
	{
	  strcpy (name, WinUsers->content [WinUsers->contentCur].item);
	  name [WIN_strlen (name)] = 0;
	  if (strcmp (NetLocalWorkGroup.Users [NetLocalWorkGroup.User].Name, name) == 0)
	  {
	    Logout_ ();
          }
          break;
        }
      }
    }
  }
}


int Init (void)
{
  int net;

  #ifdef VIDEO_MODE
  memset (pal, 0, sizeof pal);
  if (SVGA_compatible & VESA_COMPATIBLE)
  {
    pakHandle = PAK_open (PAK_FILESPEC_EMU);
    spr = SPRITE_new (pakHandle, "desktop.spr");
    SVGA_setVideoMode (VIDEO_MODE);
    TM_font = FONT_new (pakHandle, "console.fon");
    FONT_updateColors (TM_font, pal);
//    SPRITE_updateColors (spr, pal);

    PAL_set (pal);
  }
  else
  {
    printf ("VESA compatible videocard required.\n");
    return -1;
  }
  #else
    #ifdef VIDEO_MODE0
      SVGA_setVideoMode (0);
    #else
//      SVGA_setVideoMode (VGA_80x50x16TM);
//      SVGA_setVideoMode (VGA_80xXXx16TM);
    #endif
  #endif

  if (WIN_init () == 0)
  {
    MOUSE_installed = 0;
//    MOUSE_showCursor ();
    WIN_setDesktop ('', 31, NULL);
    WIN_setDefaultMiniHelp (MyDefaultMiniHelp);

    WinAbout = WIN_new (2, WIN_NONEFRAME);
    WIN_setBounds (WinAbout, 0, 0, TM_length, 1);
    WIN_setColors (WinAbout, BLACK + B_LIGHTGRAY, BLACK + B_LIGHTGRAY,
    BLUE + B_LIGHTGRAY, BLACK + B_LIGHTGRAY,
    BLACK + B_LIGHTGRAY, BLACK + B_LIGHTGRAY, BLACK + B_LIGHTGRAY);
    WIN_open (WinAbout);
    DisplayTime ();

    MyWinMiniStatus = WIN_new (2, WIN_NONEFRAME);
//    WIN_setNoneFrame (MyWinMiniStatus);
    WIN_setBounds (MyWinMiniStatus, 0, TM_width-3, TM_length, 2);
    WIN_setColors (MyWinMiniStatus, LIGHTGRAY + B_BLACK, WHITE + B_BLACK,
                                  WHITE + B_BLACK,WHITE + B_BLACK,-1, -1, -1);

//    LIGHTGRAY + B_BLACK,
//    LIGHTGRAY + B_BLACK, LIGHTGRAY + B_BLACK,
//    LIGHTGRAY + B_BLACK, LIGHTGRAY + B_BLACK,
//    LIGHTGRAY + B_BLACK);

    WIN_setMiniStatusWin (MyWinMiniStatus);

    MyWinMiniHelp = WIN_new (2, WIN_NONEFRAME);
    WIN_setBounds (MyWinMiniHelp, 0, TM_width-1, TM_length, 1);
    WIN_setColors (MyWinMiniHelp, B_LIGHTGRAY + BLACK, B_LIGHTGRAY + BLUE,
                                  B_LIGHTGRAY + BLUE, B_LIGHTGRAY + BLUE, -1, -1, -1);

    WIN_setMiniHelpWin (MyWinMiniHelp);
    WIN_redrawScreen ();

    WinWait = WIN_new (3, WIN_FRAME);
    WIN_setBounds (WinWait, -1, -1, 12, 5);
    WIN_setColors (WinWait, WHITE + B_BLUE + B_BLINK, WHITE + B_BLUE,
                            -1, -1, -1, WHITE + B_BLUE, -1);

    WIN_appendComment (WinWait, "");
    WIN_appendComment (WinWait, " Wait ... ");

    WinError = WIN_new (8, WIN_FRAME);
    WIN_setTitle (WinError, " Error ");
    WIN_setBounds (WinError, -1, -1, TM_length-5, 8);
    WIN_setColors (WinError, WHITE + B_RED, WHITE + B_LIGHTGRAY, YELLOW + B_RED, -1, -1, -1, -1);

    WinError->commsAvail.enter = 0;
    WinError->commsAvail.f10 = 0;

    WinConfirm = WIN_new (2, WIN_FRAME);
    WIN_setTitle (WinConfirm, " Note ");
    WIN_setBounds (WinConfirm, -1, -1, 50, 5);
    WIN_setColors (WinConfirm, WHITE + B_RED, -1, -1, -1, -1, -1, -1);

    // init the main window

    WaitBegin ();

    net = NET_Init ();

    WaitEnd ();

    #ifdef DEBUG_NONET
      net = 1;
    #endif

    if (!net)
    {
      Error (-1, "An IPX compatible network required for chatting using ICHAT\n"
                 "   has been not found.");
    }
    else
    {
      WinYesNo = WIN_new (2, WIN_FRAME);
      WIN_setColors (WinYesNo, 79, 79, 79, 127, 127, 127, 127);
      WIN_appendMenu (WinYesNo, "", " Yes\n", -1,
                                       "Press ~Enter~ now to choose Yes or press ~Esc~ to cancel", -1);
      WIN_appendMenu (WinYesNo, ""," No\n", -1,
                                      "Press ~Enter~ now to choose No or press ~Esc~ to cancel", -1);

      WinMessages = WIN_new (MESSAGES_MAX, WIN_FRAME);
      WIN_setTitle (WinMessages, " Messages ");
      WinMessages->selectable = 0;
      WinMessages->commsAvail.del = 1;
      WinMessages->shadow = 0;
      WIN_scrollBarEnable (WinMessages);
      WIN_setBounds (WinMessages, 0, TM_width < 30 ? 6 : 11, TM_length, TM_width < 30 ? TM_width-11 : TM_width-16);
      WIN_setColors (WinMessages, BLUE + B_CYAN, LIGHTCYAN + B_GREEN,
                                  RED + B_CYAN, YELLOW + B_CYAN, WHITE+B_CYAN,
                                  WHITE + B_CYAN, WHITE + B_CYAN);
//      WIN_open (WinMessages);

/*  extern void WIN_setColors ( TWIN *win, int Content_C,
                      int Select_C, int Highlight_C,
                      int Item_C, int PassiveSelect_C,
                      int ActiveFrame_C, int PassiveFrame_C);*/

      WinWorkGroups = WIN_new (10, WIN_FRAME);
      WIN_setTitle (WinWorkGroups, " Workgroups ");
      WinWorkGroups->shadow = 0;
      WinWorkGroups->commsAvail.ins = 1;
      WinWorkGroups->commsAvail.del = 1;
      WIN_scrollBarEnable (WinWorkGroups);
      WIN_setBounds (WinWorkGroups, 0, 0, TM_length/2, TM_width < 30 ? 6 : 11);
      WIN_setColors (WinWorkGroups, WHITE + B_BLUE, WHITE + B_GREEN,
                                    YELLOW + B_GREEN, YELLOW +B_BLUE, YELLOW + B_BLUE, -1, -1);
//      WIN_open (WinWorkGroups);

      WinUsers = WIN_new (10, WIN_FRAME);
      WIN_setTitle (WinUsers, " Users ");
      WinUsers->shadow = 0;
      WinUsers->selectable = 0;
      WinUsers->commsAvail.del = 1;
      WIN_scrollBarEnable (WinUsers);
      WIN_setBounds (WinUsers, TM_length/2, 0, TM_length/2, TM_width < 30 ? 6 : 11);
      WIN_setColors (WinUsers, WHITE + B_BLUE, WHITE + B_GREEN,
                               YELLOW + B_GREEN, YELLOW+B_BLUE, YELLOW + B_BLUE, -1, -1);

//      WIN_open (WinUsers);

      WinMain = WIN_new (20, WIN_NONEFRAME);
      WIN_setBounds (WinMain,  0, 1, 80, TM_width-5);

      WinCommand = WIN_new (2, WIN_NONEFRAME);
      WinCommand->shadow = 0;
      WinCommand->selectable = 0;
      WIN_setBounds (WinCommand, 0, TM_width-5, TM_length, 1);
      WIN_setColors (WinCommand, YELLOW + B_RED, WHITE + B_RED, -1, WHITE+ B_RED, -1, -1, -1);
      WIN_appendItem (WinCommand, WIN_ITEMT_INPUT2, "You: ", "", 0, "Type your messages here and press ~Enter~ to send them", -1);

      WinPersonal = WIN_new (2, WIN_NONEFRAME);
      WinPersonal->shadow = 0;
      WIN_setBounds (WinPersonal, 0, TM_width-4, TM_length, 1);
      WIN_setColors (WinPersonal, YELLOW + B_RED, WHITE + B_RED, -1, WHITE+ B_RED, -1, -1, -1);

      WIN_insertSubWin (WinMain, WinWorkGroups);
      WIN_insertSubWin (WinMain, WinUsers);
      WIN_insertSubWin (WinMain, WinMessages);
      WIN_insertSubWin (WinMain, WinCommand);
      WIN_open (WinMain);

      WinCreate = WIN_new (12, WIN_FRAME);
      WIN_setTitle (WinCreate, " New workgroup ");
      WIN_setBounds (WinCreate, W_CENTER, W_CENTER, 40, 12);
      WIN_setColors (WinCreate, WHITE + B_MAGENTA, BLUE + B_LIGHTGRAY, -1, WHITE + B_LIGHTGRAY, -1, -1, -1);
      WIN_appendComment (WinCreate, "");
      WIN_appendComment (WinCreate, " Enter your user name");
      CreateUser = WIN_appendItem (WinCreate, WIN_ITEMT_INPUT2, " ", "", -1, "Enter your name required for chatting here\nPress enter to login, escape to cancel", -1);

      WIN_appendComment (WinCreate, "");
      WIN_appendComment (WinCreate, " Enter workgroup description");
      CreateGroup = WIN_appendItem (WinCreate, WIN_ITEMT_INPUT2, " ", "", -1, "Enter the description for chatting group (not required)", -1);

      WIN_appendComment (WinCreate, "");
      WIN_appendComment (WinCreate, " Enter your password");
      CreatePassword = WIN_appendItem (WinCreate, WIN_ITEMT_INPUT2, " ", "", -1, "Enter your password to secure your workgroup (not required)", -1);

      WinJoinWithPassword = WIN_new (12, WIN_FRAME);
      WIN_setTitle (WinJoinWithPassword, " Join protected workgroup");
      WIN_setBounds (WinJoinWithPassword, W_CENTER, W_CENTER, 40, 9);
      WIN_setColors (WinJoinWithPassword, WHITE + B_MAGENTA, BLUE + B_LIGHTGRAY, -1, WHITE + B_LIGHTGRAY, -1, -1, -1);
      WIN_appendComment (WinJoinWithPassword, "");
      WIN_appendComment (WinJoinWithPassword, " Enter your user name");
      JoinUser = WIN_appendItem (WinJoinWithPassword, WIN_ITEMT_INPUT2, " ", "", -1, "Enter your name required for chatting here", -1);

      WIN_appendComment (WinJoinWithPassword, "");
      WIN_appendComment (WinJoinWithPassword, " Enter your password");
      JoinPassword = WIN_appendItem (WinJoinWithPassword, WIN_ITEMT_INPUT2, " ", "", -1, "Enter password to enter the selected workgroup", -1);

      WinJoin = WIN_new (12, WIN_FRAME);
      WIN_setTitle (WinJoin, " Join workgroup ");
      WIN_setBounds (WinJoin, W_CENTER, W_CENTER, 40, 6);
      WIN_setColors (WinJoin, WHITE + B_MAGENTA, BLUE + B_LIGHTGRAY, -1, WHITE + B_LIGHTGRAY, -1, -1, -1);
      WIN_appendComment (WinJoin, "");
      WIN_appendComment (WinJoin, " Enter your user name");
      JoinUser = WIN_appendItem (WinJoin, WIN_ITEMT_INPUT2, " ", "", -1, "Enter your name required for chatting here", -1);

      WinSave = WIN_new (12, WIN_FRAME);
      WIN_setTitle (WinSave, " Save messages to a file ");
      WIN_setBounds (WinSave, W_CENTER, W_CENTER, 40, 6);
      WIN_setColors (WinSave, WHITE + B_GREEN, YELLOW + B_LIGHTGRAY, -1, GREEN + B_LIGHTGRAY, -1, -1, -1);
      WIN_appendComment (WinSave, "");
      WIN_appendComment (WinSave, " Enter a file name");
      SaveName = WIN_appendItem (WinSave, WIN_ITEMT_INPUT2, " ", "", -1, "Enter filename required for saving here", -1);

//      WIN_redrawScreen ();

      NetInfo ();
      WIN_setWaitHandler (NetHandler);

      return 0;
    }
  }
  return 1;
}

void Done (void)
{
  WIN_closeAll ();

  WIN_delete (MyWinMiniHelp);
  WIN_delete (MyWinMiniStatus);

  WIN_delete (WinWorkGroups);
  WIN_delete (WinUsers);
  WIN_delete (WinStatus);
  WIN_delete (WinMessages);

  WIN_delete (WinYesNo);
  WIN_delete (WinAbout);
  WIN_delete (WinMain);
  WIN_delete (WinError);
  WIN_delete (WinConfirm);
  WIN_delete (WinWait);

  WIN_done ();
}


static void SendPersonalMessage ()
{
  char who [250];
  char name [250];

  strcpy (name, WinUsers->content [WinUsers->contentCur].item);
  name [WIN_strlen (name)] = 0;

  if (strcmp (name, NetLocalWorkGroup.Users [NetLocalWorkGroup.User].Name))
  {
    if (netslog != NETS_LOG_NONE)
    {
      sprintf (who, "You to %s: ", name);

      WIN_deleteContent (WinPersonal);
      WIN_appendItem (WinPersonal, WIN_ITEMT_INPUT2, who, "", 0, "Type your personal message here and press ~Enter~. Press ~Esc~ to cancel", -1);

      switch (WIN_exec (WinPersonal))
      {
        case WIN_COM_ENTER:
        {
          SD.type = M_PERSONAL;
          sprintf (SD.Mes, "%s", WinPersonal->content [0].item);
          NET_Send2User (name, (void *) &SD, sizeof SD);
//          strcat (SD.Mes, "\n");
          InsertMessage (NET_WhatsMyName (), SD.Mes, IChatNote, M_NOTE);
        }
      }
    }
  }
}

static void SaveMessages (void)
{
  int result, i;
  FILE *f;
  char time [256];
  char *t;

  WIN_scrollHome (WinSave);
  result = WIN_exec (WinSave);
  strcpy (FileName, WinSave->content [SaveName].item);
  if (result == WIN_COM_ENTER)
  {
    FileName [WIN_strlen (FileName)] = 0;
    if (F_exist (FileName))
    {
      if (YesNo ("Overwrite existing file ?"))
      {
	if (WinYesNo->contentCur != 0)
	{
	  return;
	}
      }
      else
      {
	return;
      }
    }
    f = fopen (FileName, "wt");
    if (f)
    {
      WaitBegin ();

      strcpy (time, GetTime () );
      if (t = strchr (time, '\n'), t != NULL)
      {
        *t = 0;
      }

      fprintf (f, "This list was generated on %s by ICHAT 1.0\n", time);
      fprintf (f, "========================================================\n\n");

      for (i = 0; i < WinMessages->contentCount; i++)
      {
        if (WinMessages->content [i].value != M_NOTE)
        {
          fprintf (f, "%s%s", WinMessages->content [i].desc, WinMessages->content [i].item);
        }
      }
      WaitEnd ();
      fclose (f);
    }
    else
    {
      Error (0, "Error saving messages. Please enter a correct file name.\n");
    }
  }
}


int NETS_Setup () // returns 0 - no network, 1 - master, 2 - slave
{
  int i,j;
  int com;
  int exitmain=-1;
  long sended ;
  long received;
  TIPXAddress *MyAddress;

  if (Init () == 0)
  {
    do
    {
      com = WIN_insert (WinMain);

      switch (com)
      {
        case WIN_COM_EXIT:  // exit setup
        case WIN_COM_ESC:  // exit setup
        {
	  if (YesNo (" Exit network setup ? "))
          {
            if (WinYesNo->contentCur == 0)
            {
              Logout ();
              exitmain = 0;
            }
          }
          break;
        }

        default:
        {
          if (WIN_subWin (WinMain) == WinWorkGroups)
          {
            switch (com)
            {
              case WIN_COM_ENTER: // create or join a workgroup
              {
                Login ();
                break;
              }
              case WIN_COM_DEL:
              {
                if (WinWorkGroups->contentCur == 0)
                {
                  Logout_ ();
                  break;
                }
              }
            }
          }

          if (WIN_subWin (WinMain) == WinUsers)
          {
            switch (com)
            {
              case WIN_COM_ENTER:
              {
                SendPersonalMessage ();
                break;
              }
              case WIN_COM_DEL:   // logout user (master only)
              {
                DeleteUser ();
                break;
              }
            }
          }

          if (WIN_subWin (WinMain) == WinCommand)
          {
            switch (com)
            {
              case WIN_COM_ENTER: // send a broadcast message
              {
                SD.type = M_PUBLIC;
                strcpy (SD.Mes, WinCommand->content [0].item);
                strcpy (WinCommand->content [0].item, "");
                NET_SendEveryone ((void *) &SD, sizeof SD);
//                strcat (SD.Mes, "\n");
                InsertMessage (NET_WhatsMyName (), SD.Mes, IChatNote, M_NOTE);
                break;
              }
            }
          }

          if (WIN_subWin (WinMain) == WinMessages)
          {
            switch (com)
            {
              case WIN_COM_DEL:
              {
                WIN_deleteItem (WinMessages, WinMessages->contentCur);
                WIN_printContent (WinMessages, 0);
                break;
              }
              case WIN_COM_ENTER:
              {
                SaveMessages ();
              }
            }
          }
        }
      }
    }
    while (exitmain == -1);

    Done ();
  }
  else
  {
    Done ();
    printf ("Not enough memory.\n");
  }

  return exitmain;
}
