
#ifndef _NODE_H_
  #define _NODE_H_

  #include "ipx.h"

  #ifdef __cplusplus
  extern "C" {
  #endif

  #define IPX_DEFAULTSOCKET 0x5452 // 21076 // 100276    // the official Cybertek IPX drivers socket
                                       //default IPX network socket

  #define NODE_MAXNODES 16             // maximum number of active nodes
  #define NODE_BROADCAST 0             // node to send data to all stations using the socket
  #define NODE_DATAFRAGSIZE 512

  #define NODE_STARTUPTIME 0

  #define NODE_DATAMAX 4               // maximum of 16 user data types are
                                       // allowed
  #define NODE_PACKETLOSTDELAY_DEFAULT 5
  extern int NODE_packetLostDelay;
  extern unsigned short IPX_socket;             // ipx socket used for sending and receiving

  extern int  NODE_Init (void);
  extern void NODE_Done (void);
  extern int  NODE_New (TIPXAddress *Address);
  extern void NODE_FlushPackets (void);
  extern void NODE_Delete (int NodeNumber);
  extern int  NODE_Send (int NodeNumber, void *Data, int DataSize, int DataType);
  extern int  NODE_Receive (int NodeNumber, void *Data, int DataSize, int DataType);
  extern TIPXAddress *NODE_GetLocalAddress (void);
  extern TIPXAddress *NODE_GetNodeAddress (int NodeNumber);
  extern void NODE_printsNodeAddress (TIPXAddress *Address, char *Str);
  extern void NODE_printsNetAddress (TIPXAddress *Address, char *Str);
  extern void NODE_scansNodeAddress (TIPXAddress *Address, char *Str);
  extern void NODE_scansNetAddress (TIPXAddress *Address, char *Str);
  extern void NODE_printsSocketAddress (TIPXAddress *Address, char *Str);
  extern void NODE_scansSocketAddress (TIPXAddress *Address, char *Str);

  extern void NODE_SetImportTime (int Node, long NewTime);
  extern void NODE_SetExportTime (int Node, long NewTime);
  extern void NODE_ClearWastePackets (void);
  extern unsigned short NODE_GetCounter (void);
  extern void NODE_Delay (int ms);
  extern int NODE_addExtraServer (TNetAddr *addr);

  #ifdef __cplusplus
  }
  #endif

#endif
