
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <ctype.h>
#include <string.h>
#include <dos.h>

#include "ipxnet.h"
#include "timer.h"
#include "cgdk.h"

#define STARTUP_TIMEOUT 2000

#define NET_BENCH_FREQ 60

char *StatusStr [4] = {"None", "Login", "Startup", "Session"};
char *LoginStr [2] = {"Enabled","Disabled"};
char *PasswordStr [2] = {"Not required","Required"};
char  *LoginResultStr [10] = {"You has been successfully logged.\n",
                       "You are alredy logged.\n",
                       "Invalid extern workgroup number.\n",
                       "Access has been denied.\n",
                       "Login is disabled.\n",
                       "Too many work groups.\n",
                       "Too many users are already logged.\n",
                       "No reply from the master.\n",
                       "No network found.\n",
                       "Unable to join, the workgroup is running session.\n"};

void Error (int err)
{
  if (err)
  {
    printf ("Successfull.\n");
  }
  else
  {
    printf ("Failed.\n");
  }
}



void DisplayGroup (TNetWorkGroup *Group)
{
  int j;

  // check the workgroup descriotion
  if (Group->Status != NET_STATUS_NOTHING)
  {
    printf ("Description  :  %s\n"
            "Logged users :  %i of %i\n"
            "Mode         :  %s\n"
            "Login        :  %s\n"
            "Password     :  %s\n"
            "Users        : ", Group->Desc,
                               Group->UsersCount,
                               Group->UsersCountMax,
                               StatusStr [Group->Status],
                               LoginStr [Group->Login],
                               PasswordStr [Group->Password]);

    for (j = 0; j < NET_MAX_USERS; j++)
    {
      if (Group->Users [j].Status != NET_USER_STATUS_FREE)
      {
        printf ("%c%i. %s\n               ",
                ( (Group == &NetLocalWorkGroup) &&
                  (j == NetLocalWorkGroup.User) ) ? '*' : ' ',
        j, Group->Users [j]. Name);
      }
    }
  }
  printf ("\n");
}

void DisplayLocalGroupInfo (void)
{
  switch (NetLocalWorkGroup.User)
  {
    case NET_USER_MASTER:
      printf ("\n"
              "You had created a local workgroup:\n"
              "----------------------------------\n");
      break;
    default:
      printf ("\n"
              "You had joined a local workgroup:\n"
              "---------------------------------\n");
      break;
  }
  DisplayGroup (&NetLocalWorkGroup);
//  printf ("Your user number is %i\n",NetLocalWorkGroup.User);
}


void DisplayWorkGroups (void)
{
  int i, j, gc, mc;

//  printf ("\nSearching for workgroups ... \n");
//  gc = NET_ScanWorkGroups ();
  gc = NET_GetWorkGroupsCount ();

  if (gc != 0)
  {
    for (i = 0; i < gc; i++)
    {
      printf ("\n"
              "An extern workgroup number %i:\n"
              "-----------------------------\n", i);

      DisplayGroup (&NetWorkGroup [i]);
      printf ("\nPress any key continue ...\n");
      getch ();
      printf ("\n");
    }
  }
  else
  {
    printf ("No extern workgroups found.\n");
  }
}

void KeyHelp (void)
{
  printf ("\n"
          "Press the following keys:\n"
          "*************************\n"
          "  <h> or <?> to help\n"
          ""
          "  <q>        to quit\n"
          "  <w>        to display extern workgroups\n"
          "  <c>        to create a new local workgroup\n"
          "  <j>        to join an extern workgroup\n"
          "  <i>        to join an extern workgroup using IPX address\n"
          "  <o>        to logout from a local workgroup\n"
          "  <k>        to logout slaves\n"
          "  <g>        to startup a network session\n"
          "  <s>        to display your status\n"
          "  <e>        to enable login\n"
          "  <d>        to disable login\n"
          "  <n>        to set the maximum number of logged users\n"
          "  <0 .. 9>   to send a message to a specified user from 0 to 9\n"
          "  <Enter>    to send a message to all users\n"
          "  <b>        start sending benchmark\n"
          "  <r>        start receiving benchmark\n"
          );

}

/*
void DisplayUserNumber ()
{
  if (NetLocalWorkGroup.Status != NET_STATUS_NOTHING)
  {
    printf ("Your connection number is: %i\n",NetLocalWorkGroup.User);
  }
}


void DisplayUserType ()
{
  DisplayUserNumber ();
  switch (NetLocalWorkGroup.User)
  {
    case NET_USER_MASTER:
      printf ("You had created a workgroup.\n");
      break;
    default:
      printf ("You had joined a workgroup.\n");
      break;
  }
}
*/

void DisplayStatus (void)
{
  switch (NetLocalWorkGroup.Status)
  {
    case NET_STATUS_NOTHING:
    {
      printf ("You are not logged.\n");
      break;
    }

    case NET_STATUS_LOGIN:
    {
      printf ("You are logged.\n");
//      DisplayUserType ();
      DisplayLocalGroupInfo ();
      break;
    }

    case NET_STATUS_SESSION:
    {
      printf ("You are running a network session.\n");
//      DisplayUserType ();
      DisplayLocalGroupInfo ();
    }
  }
}

void LogoutWorkGroup (void)
{
  if (NetLocalWorkGroup.Status != NET_STATUS_NOTHING)
  {
    switch (NetLocalWorkGroup.User)
    {
      case NET_USER_MASTER:
      {
        Error (NET_Logout ());
        break;
      }
      default:
      {
        Error (NET_Logout ());
        break;
      }
    }
  }
  else
  {
    printf ("Unable to logout. You are not logged.\n");
  }
}

void CreateWorkGroup (void)
{
  char Desc [256], Name [256], Pass [256];

  if (NetLocalWorkGroup.Status == NET_STATUS_NOTHING)
  {
    printf ("Enter your name: ");
    gets (Name);
    printf ("Enter your workgroup description: ");
    gets (Desc);
    printf ("Enter your workgroup login password: ");
//    strcpy (Pass, getpass ("Enter your password: "));
    gets (Pass);
    printf ("\n%s", LoginResultStr [NET_Create (Desc, Name, Pass)]);
  }
  else
  {
    printf ("Unable to create a local workgroup. You are already logged.\n");
  }
}

void JoinWorkGroup (void)
{
  char Name [256], Pass [256];
  int Group = 0;
  int groupCount;
  int joinResult;

  if (NetLocalWorkGroup.Status == NET_STATUS_NOTHING)
  {
    groupCount = NET_GetWorkGroupsCount ();
    if (groupCount)
    {
      printf ("Enter the workgroup number: ");
      gets (Name);
      sscanf (Name, "%i", &Group);

      printf ("Enter your name: ");
      gets (Name);
      if (NetWorkGroup [Group].Password == NET_PASSWORD_REQUIRED)
      {
        printf ("Enter the workgroup login password: ");
  //      strcpy (Pass, getpass ("Enter your password: "));
        gets (Pass);
      }

      joinResult = NET_Join (Group, Name, Pass);
      printf ("\n%s", LoginResultStr [joinResult]);
    }
    else
    {
      printf ("No workgroups found. Unable to join.\n");
    }
  }
  else
  {
    printf ("Unable to join an extern workgroup. You are already logged.\n");
  }
}

void JoinAddress (void)
{
  char Name [256], Pass [256];
  int joinResult;
  TIPXAddress adr;

  if (NetLocalWorkGroup.Status == NET_STATUS_NOTHING)
  {
    printf ("Enter the network address (01234567): ");
    gets (Name);
    Name [8] = 0;
    NODE_scansNetAddress (&adr, Name);

    printf ("Enter the node address (0123456789ab): ");
    gets (Name);
    Name [12] = 0;
    NODE_scansNodeAddress (&adr, Name);

    adr.Socket = IPX_DEFAULTSOCKET;

    printf ("Enter your name: ");
    gets (Name);
    printf ("Enter the workgroup login password: ");
    gets (Pass);

    joinResult = NET_JoinAddress (&adr, Name, Pass);
    printf ("\n%s", LoginResultStr [joinResult]);
  }
  else
  {
    printf ("Unable to join an extern workgroup. You are already logged.\n");
  }
}

void Synchronize (void)
{
  // simulate application loading - dependent of the computer running on
  printf ("Initializing ...");
  delay (STARTUP_TIMEOUT*NetLocalWorkGroup.User);
  printf (" done.\n");
  printf ("Synchronizing ...");
  NET_Synchronize ();
  printf (" done.\n");
  printf ("\n"
          "The network session has been succesfully established.\n");
}

void NetWorkStartup (void)
{
  if ((NetLocalWorkGroup.User == NET_USER_MASTER) && (NetLocalWorkGroup.Status != NET_STATUS_NOTHING))
  {
    switch (NetLocalWorkGroup.Status)
    {
      case NET_STATUS_SESSION:
      {
        printf ("The network session has already started up.\n");
        break;
      }
      case NET_STATUS_LOGIN:
      {
        Error (NET_Startup ());
        Synchronize ();
        break;
      }
    }
  }
  else
  {
    printf ("Unable to startup a network session. You are not logged as a master.\n");
  }
}


int Input (void)
{
  int i = 0;

  if (kbhit ())
  {
    i = getche ();
    printf ("\n");
  }
  return i;
}

typedef struct
{
  char Mes [256];
} SData;


void Send (int User)
{
  SData SD;

  if (NetLocalWorkGroup.Status != NET_STATUS_NOTHING)
  {
    if (NetLocalWorkGroup.User == User)
    {
      printf ("You cannot send a message to yourself.\n");
    }
    else
    {
      if ((NetLocalWorkGroup.Users [User].Status == NET_USER_STATUS_FREE) ||
          (User >= NET_MAX_USERS))
      {
        printf ("Unable to send a message. The specified user is not logged.\n");
      }
      else
      {
        printf ("Enter a message to send: ");
        gets (SD.Mes);
        Error (NET_Send (User, (void *) &SD, sizeof SD));
      }
    }
  }
  else
  {
    printf ("Unable to send a message. You are not logged.\n");
  }
}

void SendAny (void)
{
  SData SD;

  if (NetLocalWorkGroup.Status != NET_STATUS_NOTHING)
  {
    if (NetLocalWorkGroup.UsersCount <= 1)
    {
      printf ("No users to send a message.\n");
    }
    else
    {
      printf ("Enter a message to send: ");
      gets (SD.Mes);
      Error (NET_SendEveryone ((void *) &SD, sizeof SD));
    }
  }
  else
  {
    printf ("Unable to send a message. You are not logged.\n");
  }
}

void SendN (void)
{
  char UserStr [256];
  int User;

  if (NetLocalWorkGroup.Status != NET_STATUS_NOTHING)
  {
    printf ("Enter the number of the user to send the message: ");
    gets (UserStr);
    sscanf (UserStr, "%i", User);
    Send (User);
  }
  else
  {
    printf ("Unable to send a message. You are not logged.\n");
  }
}

void Receive (void)
{
  int i;
  SData SD;

  if (NetLocalWorkGroup.Status != NET_STATUS_NOTHING)
  {
    while (((i = NET_ReceiveEveryone ( (void *) &SD, sizeof SD)) != -1))
    {
      printf ("%s: %s\n", NetLocalWorkGroup.Users [i].Name, SD.Mes);
    }
  }
}

void ClearSlave (void)
{
  char s [256];
  int User = 0;

  if ((NetLocalWorkGroup.Status != NET_STATUS_NOTHING) &&
      (NetLocalWorkGroup.User == NET_USER_MASTER))
  {
    printf ("Enter the number of the slave to logout: ");
    gets (s);
    sscanf (s, "%i", &User);
    if (NetLocalWorkGroup.User == User)
    {
      printf ("You are alowed to clear slaves only.\n");
    }
    else
    {
      Error (NET_ClearSlave (User));
    }
  }
  else
  {
    printf ("You must be logged as a master to logout slaves.\n");
  }
}

int ChangeStatusCheck (void)
{
  if ((NetLocalWorkGroup.User == NET_USER_MASTER) && (NetLocalWorkGroup.Status != NET_STATUS_NOTHING))
  {
    if (NetLocalWorkGroup.Status == NET_STATUS_LOGIN)
    {
      return 0;
    }
    else
    {
      printf ("Unable to enable/disable login or set the maximum number of logged users\n"
              "during a started up network session.\n");
      return 2;
    }
  }
  else
  {
    printf ("To enable/disable login or set the maximum number of logged users,\n"
            "you must be logged as a master.\n");
    return 1;
  }
}

void SetMaxUsers (void)
{
  char s [256];
  int n;

  if ( ChangeStatusCheck () == 0)
  {
    printf ("Enter the maximum number of logged users: ");
    gets (s);
    sscanf (s, "%i", &n);

    Error (NET_SetMaxUsers (n));
  }
}

void EnableLogin (void)
{
  if ( ChangeStatusCheck () == 0)
  {
    Error ( NET_EnableLogin () );
  }
}

void DisableLogin (void)
{
  if ( ChangeStatusCheck () == 0)
  {
    Error (NET_DisableLogin ());
  }
}

void Application (void)
{
//  delay (100);
}

void netUpdateHandler (int result)
{
  switch (result)
  {
    case NET_UPDATE_CLEARED: // same as NET_UPDATE_CLEARED_U:
    {
      printf ("Your connection has been terminated by the master !\n");
      break;
    }

    case NET_UPDATE_CLEARED+1:
    case NET_UPDATE_CLEARED+2:
    case NET_UPDATE_CLEARED+3:
    /* ... */
    {
      printf ("An user has been logged out by the master.\n");
      break;
    }

    case NET_UPDATE_LOGIN+1:
    case NET_UPDATE_LOGIN+2:
    case NET_UPDATE_LOGIN+3:
    /* ... */
    {
      printf ("An user has been logged.\n");
      break;
    }

    case NET_UPDATE_LOGOUT: // same as NET_UPDATE_LOGOUT_MASTER:
    {
      printf ("Your local workgroup has been terminated by the master.\n");
      break;
    }

    case NET_UPDATE_LOGOUT+1:
    case NET_UPDATE_LOGOUT+2:
    case NET_UPDATE_LOGOUT+3:
    /* ... */
    {
      printf ("An user has logged out.\n");
      break;
    }

    case NET_UPDATE_MISCINFO:
    {
      // check if session has started up
      if (NetLocalWorkGroup.Status == NET_STATUS_STARTUP)
      {
        Synchronize ();
      }
      else
      {
        printf ("Your local workgroup status has been updated.\n");
        break;
      }
    }
  }
}


#define TEST_COUNT 100

void sendBenchmark (void)
{
  long result, i, count, time;
  char s [256];

  count = 0;
  printf ("Sending messages, press any key to quit ...\n");

  TIMER_start ();

  if (NetLocalWorkGroup.Status != NET_STATUS_NOTHING)
  {
    if (NetLocalWorkGroup.UsersCount <= 1)
    {
      printf ("No users to send a message.\n");
      return;
    }
  }
  else
  {
    printf ("Unable to send a message. You are not logged.\n");
    return;
  }

  while (!kbhit ())
  {
    for (i = 0; i < TEST_COUNT; i++)
    {
      time = TIMER_time;
      while ((TIMER_time - time) <= (1000/NET_BENCH_FREQ) )
        ;
      sprintf (s, "%li", count+i);
      NET_SendEveryone (s, sizeof s);
    }
    result = NET_Update ();
    if (result)
    {
//      printf ("\n");
      netUpdateHandler (result);
//      break;
    }

    count += TEST_COUNT;
    printf ("\rSended %li messages, time = %li ms, transfer speed = %li kB/s.",
            (long) count, TIMER_time, (long) ((1000*(count/2)) / TIMER_time) );
    fflush (stdout);
  }

  printf ("\n");

  TIMER_reset ();
}


void receiveBenchmark (void)
{
  long result, i, count, time, last, lost;
  char s [256];

  count = 0;
  printf ("Receiving messages, press any key to quit ...\n");

  TIMER_start ();

  while (!TIMER_time)
    ;

  if (NetLocalWorkGroup.Status != NET_STATUS_NOTHING)
  {
    if (NetLocalWorkGroup.UsersCount <= 1)
    {
      printf ("No users to receive messages.\n");
      return;
    }
  }
  else
  {
    printf ("Unable to receive messages. You are not logged.\n");
    return;
  }

  last = 0;
  count = 0;
  lost = 0;

  while (!kbhit ())
  {
    memset (s, 0, sizeof s);
    while (i = NET_ReceiveEveryone (s, sizeof s), i != -1)
    {
      sscanf (s, "%li", &result);
      lost += (result - last) - 1;
      last = result;
      count++;
    }

    result = NET_Update ();
    if (result)
    {
//      printf ("\n");
      netUpdateHandler (result);
//      break;
    }

    printf ("\rReceived %4li messages, %4li lost, time = %6li ms, speed = %6li kB/s.",
            count, lost, TIMER_time, (long) ((1000*(count/2)) / TIMER_time) );
    fflush (stdout);
  }

  printf ("\n");

  TIMER_reset ();
}

int main (void)
{
  int UpdateResult;
  char key;
  long sended ;
  long received;
  int netInit;
  char node_adr [12+1];
  char net_adr [8+1];
  TIPXAddress *MyAddress;

  begin:

  printf ("\n"
	  "NET - IPX network interface console test program\n"
	  "\n%s\n", CGDK_copyright);

  TIMER_init (TIMER_OLDFREQ_DEF);

  IPX_socket = IPX_DEFAULTSOCKET;
  netInit = NET_Init ();

  if (!netInit)
  {
    printf ("IPX compatible network not found.\n");
    CGDK_exit ("", EXIT_FAILURE);
  }

  NODE_packetLostDelay = NODE_PACKETLOSTDELAY_DEFAULT;

  printf ("\n"
          "Press the <h> key for help.\n\n");

  MyAddress = NODE_GetLocalAddress ();
  NODE_printsNetAddress (MyAddress, net_adr);
  NODE_printsNodeAddress (MyAddress, node_adr);

  printf ("\nLocal machine node address is: %s:%s\n\n", net_adr, node_adr);

  DisplayWorkGroups ();

  while (1)
  {
    Application ();

    key = tolower (Input ());
    switch (key)
    {
      case 'h':
      case '?':
        KeyHelp ();
        break;
      case 'w':
        DisplayWorkGroups ();
        break;
      case 'c':
        CreateWorkGroup ();
        break;
      case 'j':
        JoinWorkGroup ();
        break;
      case 'i':
        JoinAddress ();
        break;
      case 'g':
        NetWorkStartup ();
        break;
      case 'o':
        LogoutWorkGroup ();
        break;
      case 'q':
	NET_Done ();
	TIMER_done ();
	CGDK_exit ("", EXIT_SUCCESS);
	break;
      case '\r':
	SendAny ();
	break;
      case 'e':
	EnableLogin ();
	break;
      case 'd':
        DisableLogin ();
        break;
      case 's':
        DisplayStatus ();
        break;
      case 'k':
        ClearSlave ();
        break;
      case 'n':
        SetMaxUsers ();
        break;
      case 'b':
        sendBenchmark ();
        break;
      case 'r':
        receiveBenchmark ();
        break;
      default:
      {
        if ((key >= '0') && (key <= '9'))
        {
          Send (key-'0');
        }
      }

      while ((UpdateResult = NET_Update ()) != NET_UPDATE_NOTHING)
      {
        netUpdateHandler (UpdateResult);
      }
    }

    Receive ();
  }

  return 0;
}
