
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <dos.h>

#include "ipxnode.h"
#include "cgdk.h"
#include "timer.h"

#define SEND_MAX 10000000
#define SEND_NMAX 10
#define SEND_DELAY 50 // (5 frames per second)

char s [4096] = "";

int main (void)
{
  char node_adr [12];
  char net_adr [8];
  long sended = 0;
  long received = 0;
  int i;

  TIPXAddress *MyAddress;

  printf ("\nNODE - low level ipx network interface test program\n"
          "\n%s\n", CGDK_copyright);

  TIMER_init (TIMER_OLDFREQ_DEF);  

  if (!NODE_Init (IPX_DEFAULTSOCKET))
  {
    printf ("IPX compatible network not found.\n");
    exit (EXIT_FAILURE);
  }

  MyAddress = NODE_GetLocalAddress ();
  NODE_printsNodeAddress (MyAddress, node_adr);

  printf ("\nLocal machine node address is: 0x%s\n\n"
          "Enter a message to send: ", node_adr);
  gets (s);

  printf ("\n\nSending data ... hit any key to abort.\n");
  while (!kbhit () && (sended < SEND_MAX))
  {
    if (!NODE_Send (NODE_BROADCAST, s, 100, 0))
    {
      printf ("\nError sending data.\n\n");
      exit (EXIT_FAILURE);
    }
    else
    {
      putch ('*');
      sended++;
/*
      if ((sended % SEND_NMAX) == 0)
      {
        NODE_SetExportTime (NODE_BROADCAST, NODE_STARTUPTIME);
        printf ("\n");
      }
*/
    }
    delay (SEND_DELAY);
  }
  if (sended < SEND_MAX)
    getch ();
  printf ("\n%li messages has been sended.\n", sended);

  printf ("\n\nReceiving data ... hit any key to continue.\n");

  while (!kbhit ())
  {
    while (NODE_Receive (NODE_BROADCAST, s, 100, 0))
    {
      received++;
      putch ('*');
    }
    delay (SEND_DELAY);
  }

  if (received)
  {
    printf ("\n%li (sorted) messages has been received: %s\n",received,s);

  }
  else
  {
    printf ("\nNo message received.\n");
  }

  NODE_Done ();

  return EXIT_SUCCESS;
}
