
#include <stdlib.h>
#include <dos.h>
#include <conio.h>

#include "timer.h"
#include "dpmi.h"
#include "cgdk.h"

#define TIMER_INT 0x08
//#define TIMER_PIC 0x20
//#define END_OF_INT 0x20

#define TIMER_SELECT 0x43
#define SELECT_TIMER_FREQ 0x34
#define TIMER_OUTPUT 0x40

extern void far interrupt Timer_Handler (INTERRUPT_ARG);

static long TIMER_oldLimit;

volatile long TIMER_time;
volatile long TIMER_timeTotal;
volatile long TIMER_ticks;
volatile long TIMER_ticksTotal;

volatile long TIMER_retrace;
//volatile long TIMER_retraceTrap;
volatile long TIMER_retraceTime;

//int TIMER_retraceTrapDisable;
long TIMER_retraceTimeMax;
double TIMER_retraceTimeMaxF;
double TIMER_retraceTimeMaxF09;
double TIMER_retraceTimeMaxF01;
double TIMER_oldFreq;

static unsigned long Counter;
static volatile long ClockTicks;
static volatile long TimerRun;

//static int programTimerRound;

static void far interrupt (*BIOSTimerHandler) (INTERRUPT_ARG);



static void programTimer (void)
{
  int lCounter, hCounter;

  lCounter = los (Counter);
  hCounter = his (Counter);

  outp (TIMER_SELECT, SELECT_TIMER_FREQ);
  outp (TIMER_OUTPUT, lCounter);
  outp (TIMER_OUTPUT, hCounter);

/*  if (programTimerRound)
  {
    programTimerRound = 0;
    TIMER_handler ();
  }
  else
  {
    programTimerRound = 1;
  }*/
}

void TIMER_setOldFreq (double oldFreq)
{
  TIMER_oldFreq = oldFreq;
  TIMER_oldLimit = TIMER_8053 / oldFreq;
}

void TIMER_init (double oldFreq)
{
  TIMER_setOldFreq (oldFreq);

  if (BIOSTimerHandler == NULL)
  {
//    _atexit (TIMER_done);

    ClockTicks = 0;
    TIMER_time = TIMER_ticks = TIMER_timeTotal = TIMER_ticksTotal = 0;
    TIMER_reset ();
    BIOSTimerHandler = _dos_getvect (TIMER_INT);
    _dos_setvect (TIMER_INT, Timer_Handler);
    Counter = TIMER_OUT; // 0x1234DC / TIMER_FREQ;

    programTimer ();
  }
}

void TIMER_done (void)
{
  if (BIOSTimerHandler != NULL)
  {
    outp (TIMER_SELECT, SELECT_TIMER_FREQ);
    outp (TIMER_OUTPUT, 0);
    outp (TIMER_OUTPUT, 0);
    _dos_setvect (TIMER_INT, BIOSTimerHandler);
    BIOSTimerHandler = NULL;
  }
}



void TIMER_reset (void)
{
  if (BIOSTimerHandler != NULL)
  {
    TimerRun = 0;
    TIMER_time = TIMER_ticks = 0;
//    programTimer ();
  }
}

void TIMER_start (void)
{
  if (BIOSTimerHandler != NULL)
  {
    TimerRun = 1;
  }
}

void TIMER_stop (void)
{
  TimerRun = 0;
}



void TIMER_retraceReprogram (void)
{
//  if (!TIMER_retraceTrapDisable)
  {
    TIMER_retraceTime = 0;
    TIMER_retrace++;
//    programTimer ();
  }
}


#pragma off (check_stack)

#pragma saveregs
void far interrupt Timer_Handler (INTERRUPT_ARG)
{
  TIMER_ticksTotal++;
  TIMER_timeTotal = (1000*TIMER_ticksTotal)/TIMER_FREQ;
  ClockTicks += Counter;
  if (TimerRun)
  {
    TIMER_ticks++;
    TIMER_time = (1000*TIMER_ticks)/TIMER_FREQ;
  }

  TIMER_retraceTime++;

//  if (TIMER_retraceTime >= TIMER_retraceTimeMax)
//  {
//    TIMER_retraceTime -= TIMER_retraceTimeMax;
//    TIMER_retrace++;
//  }

  if (ClockTicks > TIMER_oldLimit)
  {
    BIOSTimerHandler ();
    ClockTicks -= TIMER_oldLimit;
  }
  else
  {
    outp (PIC, END_OF_PIC);
  }

  /*
  if (!TIMER_retraceTrapDisable)
  {
    if (SVGA_retraceDetect ())
    {
      TIMER_retraceTrap++;
      TIMER_retraceReinit ();
    }
  }
  */
}

void TIMER_wait (long waitCount)
{
  long time;

  if (BIOSTimerHandler != NULL)
  {
    time = TIMER_ticksTotal;

    while ((TIMER_ticksTotal - time) < waitCount)
      ;
  }
  else
  {
    delay (waitCount);
  }
}

void TIMER_delay (long ms)
{
  if (BIOSTimerHandler != NULL)
  {
    ms = (long) (TIMER_FREQ*ms) / 1000;
    TIMER_wait (ms);
  }
  else
  {
    delay (ms);
  }
}

void TIMER_sleep (long seconds)
{
  long ms;

  if (BIOSTimerHandler != NULL)
  {
    ms = (long) TIMER_FREQ*seconds;
    TIMER_wait (ms);
  }
  else
  {
    sleep (seconds);
  }
}


void TIMER_beep (long freq, long msDelay)
{
  sound (freq);
  TIMER_delay (msDelay);
  nosound ();
}
