
#ifndef _TIMER_H
  #define _TIMER_H

  #ifdef __cplusplus
  extern "C" {
  #endif

  #define TIMER_8053 0x1234dc
  #define TIMER_OLDFREQ_DEF ((double)TIMER_8053/0xFFFF)

  #ifdef __TURBOC__
    #define TIMER_OUT 0x1000
//    #define TIMER_FREQ TIMER_OLDFREQ_DEF
  #else
    #define TIMER_OUT 0x0800
  #endif

  #define TIMER_FREQ ((double)TIMER_8053/TIMER_OUT) // 3287 // 5233.25 // 19 // 1000

  extern volatile long TIMER_time;
  extern volatile long TIMER_timeTotal;
  extern volatile long TIMER_ticks;
  extern volatile long TIMER_ticksTotal;

  extern volatile long TIMER_retrace;
//  extern volatile long TIMER_retraceTrap;
  extern volatile long TIMER_retraceTime;

//  extern int TIMER_retraceTrapDisable;
  extern long TIMER_retraceTimeMax;
  extern double TIMER_retraceTimeMaxF;
  extern double TIMER_retraceTimeMaxF09;
  extern double TIMER_retraceTimeMaxF01;

//  extern void TIMER_retraceInit (void);
  extern void TIMER_retraceReprogram (void);
  extern void TIMER_init (double oldFreq);
  extern void TIMER_setOldFreq (double oldFreq);

  extern void TIMER_start (void);
  extern void TIMER_stop (void);
  extern void TIMER_reset (void);
  extern void TIMER_done (void);
  extern void TIMER_wait (long waitCount);
  extern void TIMER_delay (long ms);
  extern void TIMER_sleep (long seconds);
  extern void TIMER_beep (long freq, long msDelay);

  #ifdef __cplusplus
  }
  #endif

#endif
